From 356aa68191f230e3b2f2a3aaf8da34e9f930437a Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Aug 11 2017 13:00:29 +0000
Subject: [PATCH 1/3] Use Pagure instead of pkgdb in get_user_packages


---

diff --git a/hubs/tests/utils/test_packages.py b/hubs/tests/utils/test_packages.py
new file mode 100644
index 0000000..5b258d1
--- /dev/null
+++ b/hubs/tests/utils/test_packages.py
@@ -0,0 +1,65 @@
+from __future__ import unicode_literals
+
+import dogpile
+import dogpile.cache
+from mock import Mock, patch
+
+from hubs.tests import APPTest
+from hubs.utils.cache import cache
+from hubs.utils.packages import get_user_packages
+
+
+class PackageUtilsTest(APPTest):
+
+    def setUp(self):
+        super(PackageUtilsTest, self).setUp()
+        # Use a memory backend, not the default null backend, or we can't test
+        # the caching feature.
+        cache.configure(backend='dogpile.cache.memory',
+                        replace_existing_backend=True)
+        cache.delete("owned_packages:abompard")
+
+    def _is_cached(self):
+        result = cache.get(b"owned_packages:abompard", ignore_expiration=True)
+        return not isinstance(result, dogpile.cache.api.NoValue)
+
+    def test_get_user_packages(self):
+        pkgs = get_user_packages("abompard", use_cache=False)
+        self.assertEqual(len(pkgs), 280)
+        for pkg in pkgs:
+            self.assertEqual(type(pkg), type(""))
+        self.assertFalse(self._is_cached())
+
+    def test_get_user_packages_owned(self):
+        pkgs = get_user_packages("abompard", only_owned=True, use_cache=False)
+        self.assertEqual(len(pkgs), 18)
+        for pkg in pkgs:
+            self.assertEqual(type(pkg), type(""))
+        self.assertFalse(self._is_cached())
+
+    @patch("hubs.utils.packages.requests")
+    def test_get_user_packages_invalid(self, requests):
+        response = Mock()
+        response.json.side_effect = ValueError("invalid value")
+        requests.get.return_value = response
+        pkgs = get_user_packages("abompard", use_cache=False)
+        self.assertListEqual(pkgs, [])
+
+    @patch("hubs.utils.packages.requests")
+    def test_get_user_packages_cache(self, requests):
+        response = Mock()
+        response.json.return_value = {
+            "forks": [],
+            "repos": [],
+            "user": {
+                "name": "abompard",
+                "fullname": "abompard",
+            },
+        }
+        requests.get.return_value = response
+        get_user_packages("abompard", use_cache=True)
+        self.assertTrue(self._is_cached())
+        self.assertEqual(requests.get.call_count, 1)
+        get_user_packages("abompard", use_cache=True)
+        self.assertTrue(self._is_cached())
+        self.assertEqual(requests.get.call_count, 1)
diff --git a/hubs/utils/packages.py b/hubs/utils/packages.py
new file mode 100644
index 0000000..0335ceb
--- /dev/null
+++ b/hubs/utils/packages.py
@@ -0,0 +1,53 @@
+from __future__ import unicode_literals
+
+import logging
+
+import requests
+
+from .cache import cache
+
+log = logging.getLogger(__name__)
+
+PAGURE_URL = "https://src.fedoraproject.org"
+
+
+def get_user_packages(username, only_owned=False, use_cache=True):
+    """Get the list of packages owned by the username.
+
+    Args:
+        username (str): The FAS username.
+        only_owned (bool): Only return the package names owned by the user, not
+            those they are co-maintainer of.
+        use_cache (bool): Whether to cache the results for a few minutes.
+            Defaults to ``True``.
+
+    Returns:
+        The list of package names sorted alphabetically.
+    """
+    def get_data():
+        url = "/".join([PAGURE_URL, "api", "0", "user", username])
+        try:
+            response = requests.get(url, timeout=20)
+        except (requests.exceptions.ConnectionError,
+                requests.exceptions.Timeout):
+            log.warning("Could not get the list of owned packages for %s",
+                        username)
+            return []
+        try:
+            data = response.json()
+        except ValueError:
+            log.warning(
+                "Invalid JSON response getting the list of packages "
+                "owned by %s: %s", username, response.text)
+            return []
+        return sorted(set(
+            repo['name'] for repo in data["repos"]
+            if not only_owned or repo["user"]["name"] == username
+            ))
+    if not use_cache:
+        return get_data()
+    else:
+        cache_key = ":".join(["owned_packages", username])
+        # Cache for 5 minutes, it seems reasonable.
+        # TODO: invalidate on fedmsg?
+        return cache.get_or_create(cache_key.encode("utf-8"), get_data, 5 * 60)
diff --git a/hubs/widgets/bugzilla/__init__.py b/hubs/widgets/bugzilla/__init__.py
index 8731c8a..363f7b2 100644
--- a/hubs/widgets/bugzilla/__init__.py
+++ b/hubs/widgets/bugzilla/__init__.py
@@ -4,7 +4,7 @@ import logging
 
 import pkgwat.api
 
-from hubs.utils.pkgdb import get_owned_packages
+from hubs.utils.packages import get_user_packages
 from hubs.widgets import validators
 from hubs.widgets.base import Widget
 from hubs.widgets.view import RootWidgetView
@@ -48,14 +48,13 @@ class BaseView(RootWidgetView):
 class GetIssues(CachedFunction):
     """Returns data for Bugzilla widget.
 
-    Queries pkgdb api for package list of the user and bugzilla for
-    corresponding issues.
+    Queries Bugzilla for issues on the user's packages.
     """
 
     def execute(self):
         username = self.instance.config["username"]
         max_num = int(self.instance.config.get("max", 3))
-        owned = get_owned_packages(username)
+        owned = get_user_packages(username)
         issues = []
         for pkg_name in owned:
             if len(issues) == max_num:
@@ -79,5 +78,5 @@ class GetIssues(CachedFunction):
         except KeyError:
             return False
         username = self.instance.config["username"]
-        owned = get_owned_packages(username)
+        owned = get_user_packages(username)
         return (component in owned)

